package com.goafanti.expenseAccount.service.impl;

import com.goafanti.admin.bo.AdminListBo;
import com.goafanti.common.bo.AdminNoticeBo;
import com.goafanti.common.bo.EmailBo;
import com.goafanti.common.constant.AFTConstants;
import com.goafanti.common.dao.*;
import com.goafanti.common.enums.NoticeStatus;
import com.goafanti.common.enums.NoticeTypes;
import com.goafanti.common.error.BusinessException;
import com.goafanti.common.model.*;
import com.goafanti.common.utils.*;
import com.goafanti.core.mybatis.BaseMybatisDao;
import com.goafanti.core.mybatis.page.Pagination;
import com.goafanti.core.shiro.token.TokenManager;
import com.goafanti.expenseAccount.Enums.EAProcessStatus;
import com.goafanti.expenseAccount.bo.*;
import com.goafanti.expenseAccount.service.ExpenseAccountService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.cache.annotation.CacheEvict;
import org.springframework.cache.annotation.Cacheable;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.math.BigDecimal;
import java.util.*;

@Service
public class ExpenseAccountServiceImpl extends BaseMybatisDao<ExpenseAccountMapper> implements ExpenseAccountService {
    @Autowired
    private  AdminMapper adminMapper;
    @Autowired
    private ExpenseAccountMapper expenseAccountMapper;
    @Autowired
    private PublicReleaseMapper publicReleaseMapper;
    @Autowired
    private ExpenseAccountLogMapper expenseAccountLogMapper;
    @Autowired
    private AsyncUtils asyncUtils;
    @Autowired
    private WeChatUtils weChatUtils;
    @Autowired
    private ExpenseAccountDetailsMapper expenseAccountDetailsMapper;
    @Autowired
    private ExpenseAccountPrivateMapper expenseAccountPrivateMapper;
    @Autowired
    private ExpenseAccountExamineMapper expenseAccountExamineMapper;





    @Override
    public Integer add(InputExpenseAccount in) {
        //设置付款部门和支付部门
        if (in.getAid()!=null){
            Admin admin = adminMapper.selectByPrimaryKey(in.getAid());
            in.setAname(admin.getName());
            in.setApplyDep(admin.getDepartmentId());
            in.setPayDep(admin.getDepartmentId());
        }
        //如果关联公出，获取公出信息
        if (in.getPrid()!=null){
            PublicRelease pr = publicReleaseMapper.selectByPrimaryKey(in.getPrid());
            in.setReleaseStart(pr.getReleaseStart());
            in.setReleaseEnd(pr.getReleaseEnd());
            in.setDistrictName(pr.getDistrictName());
            in.setUserNames(pr.getUserNames());
            in.setDuration(pr.getDuration());
        }
        Integer eaaid = expenseAccountPrivateMapper.selectByaidDefault(in.getAid());
        in.setEaaid(eaaid);
        //判断报销类型，0=固定费用，1=报销到订单
        if (in.getOrderNo()==null){
            in.setTargetType(0);
        }else {
            in.setTargetType(1);
        }
        expenseAccountMapper.insertSelective(in);
        addExpenseAccountExamine(in.getId());
        return in.getId();
    }

    /**
     * 新增报销审核流程
     * @param id 报销编号
     */
    private void addExpenseAccountExamine(Integer id) {
        List<ExpenseAccountExamine> list=new ArrayList<>();
        String aid = TokenManager.getAdminId();
        Admin admin = adminMapper.selectByPrimaryKey(aid);
        for (int i=1;i<5;i++){
            if (i==1){
                //新增一级
                ExpenseAccountExamine eae=new ExpenseAccountExamine(id,i);
                AdminNoticeBo a = adminMapper.selectMyAndSuperBySuperId(aid);
                if (a.getSuperId()!=null){
                    eae.setAuditor(a.getSuperId());
                    eae.setAuditorname(a.getSuperName());
                }else {
                    eae.setAuditor(a.getId());
                    eae.setAuditorname(a.getName());
                }
                if (eae.getAuditor().equals(aid))eae.setStatus(1);
                else  eae.setStatus(0);
                list.add(eae);
            }else if (i==2){
                ExpenseAccountExamine eae=new ExpenseAccountExamine(id,i);
                Admin admin2 = adminMapper.selectFinanceAdminByAid(aid);
                if (admin2==null){
                    throw new BusinessException("发起人部门财务专员不存在。");
                }
                eae.setAuditor(admin2.getId());
                eae.setAuditorname(admin2.getName());
                if (eae.getAuditor().equals(aid))eae.setStatus(1);
                else  eae.setStatus(0);
                list.add(eae);
            }else if (i==3){
                List<Admin> admins = adminMapper.listAdminBydepIdAndRoleType(admin.getDepartmentId(), AFTConstants.SALESMAN_ADMIN);
                if (admins.isEmpty())throw new BusinessException("发起人部门营销管理员不存在。");
                for (Admin e : admins) {
                    ExpenseAccountExamine eae=new ExpenseAccountExamine(id,i);
                    eae.setAuditor(e.getId());
                    eae.setAuditorname(e.getName());
                    if (eae.getAuditor().equals(aid))eae.setStatus(1);
                    else  eae.setStatus(0);
                    list.add(eae);
                }
            }else if (i==4){
                List<Admin> admins = adminMapper.selectAdminByRoleType(AFTConstants.All_CED_AND_CHAIRMAN);
                for (Admin e : admins) {
                    ExpenseAccountExamine eae=new ExpenseAccountExamine(id,i);
                    eae.setAuditor(e.getId());
                    eae.setAuditorname(e.getName());
                    if (eae.getAuditor().equals(aid))eae.setStatus(1);
                    else  eae.setStatus(0);
                    list.add(eae);
                }
            }

        }
        expenseAccountExamineMapper.insertBatch(list);
    }

    /**
     * 新增报销日志
     * @param eaid 报销编号
     * @param status 状态 0发起 1通过 2完成 3驳回 4修改
     * @param str 备注
     */
    private void addExpenseAccountLog(Integer eaid, Integer status,Integer processStatus,String aid, String str) {
        addExpenseAccountLog(eaid,status,processStatus,aid,str,null);
    }

    /**
     * 新增报销日志
     * @param eaid 报销编号
     * @param status 状态 0发起 1通过 2完成 3驳回 4修改
     * @param str 备注
     */
    private void addExpenseAccountLog(Integer eaid, Integer status,Integer processStatus,String aid, String str,Date date) {
        if (aid==null)aid=TokenManager.getAdminId();
        ExpenseAccountLog eaLog=new ExpenseAccountLog();
        eaLog.setEaid(eaid);
        eaLog.setStatus(status);
        eaLog.setRemarks(str);
        eaLog.setProcessStatus(processStatus);
        eaLog.setAuditor(aid);
        if (date !=null)eaLog.setCreateTime(date);
        expenseAccountLogMapper.insertSelective(eaLog);
    }

    /**
     * 发起、驳回发起流程切换和日志站内信发送
     */
    private void addExpenseAccountLogAndNoticEmail(InputExpenseAccount in, Integer status, String str) {
        String aid=TokenManager.getAdminId();
        addExpenseAccountLog(in.getId(),status,in.getProcessStatus(),aid,str);
        Admin admin = adminMapper.selectByPrimaryKey(aid);
        if(in.getStatus()==1){
            in.setProcessStatus(1);
        }
        if (admin.getSuperiorId()==null||admin.getId().equals(admin.getSuperiorId())){
            String str2=String.format("重复审核人跳过[%s]。",EAProcessStatus.getDesc(in.getProcessStatus()));
            Date date=new Date();
            date.setTime(date.getTime()+1000L);
            addExpenseAccountLog(in.getId(),1,in.getProcessStatus(),aid,str2,date);
            in.setProcessStatus(in.getProcessStatus()+1);
        }
        createExamineByProcess(in);
    }


    /**
     * 判断审核流程与发送日志与邮件
     */
    private void createExamineByProcess(InputExpenseAccount in) {
        //审核流程推送到最新
        examineByprocess(in);
        List<Admin> aids=new ArrayList<>();
        AdminListBo admin = adminMapper.getDeptNameByAid(in.getAid());
        if(in.getProcessStatus()== EAProcessStatus.SJSH.getCode()){
            //获取上级
            Admin superAdmin = adminMapper.selectByPrimaryKey(admin.getSuperiorId());
            aids.add(superAdmin);
            in.setExamineName(superAdmin.getName());
        }else if (in.getProcessStatus()== EAProcessStatus.CWSH.getCode()){
            //获取财务负责人
            Admin finaceAdmin = adminMapper.selectByPrimaryKey(admin.getDepFinance());
            aids.add(finaceAdmin);
            in.setExamineName(finaceAdmin.getName());
        }else if (in.getProcessStatus()== EAProcessStatus.ZJLSH.getCode()){
            //获取部门负责人
            List<Admin> list = adminMapper.listAdminBydepIdAndRoleType(admin.getDepartmentId(), AFTConstants.SALESMAN_ADMIN);
            if (!list.isEmpty())aids.addAll(list);
            in.setExamineName(getAdmins(list));
        }else if (in.getProcessStatus()== EAProcessStatus.DSZSH.getCode()){
            //获取总裁、董事长等审核
            List<Admin> list = adminMapper.selectAdminByRoleType(AFTConstants.All_CED_AND_CHAIRMAN);
            if (!list.isEmpty())aids.addAll(list);
            in.setExamineName(getAdmins(list));
        }
        StringBuffer str=new StringBuffer().append("您有报销需要审核，").append("报销编号[").append(in.getId()).append("]").append("，请查看并审核。");
        addNoticeAndEmail(in,  EAProcessStatus.SJSH.getCode(),str.toString(), admin.getName(),aids);
    }

    @Override
    @Transactional
    public int update(InputExpenseAccount in) {
        OutExpenseAccount useEA = expenseAccountMapper.selectByid(in.getId());
        if (useEA.getStatus()!=0&&useEA.getStatus()!=3){
            throw new BusinessException("不能操作审核中与完成的订单");
        }
        if (in.getStartTimeStr()!=null&&in.getEndTimeStr()!=null){
            in.setReleaseStart(DateUtils.StringToDate(in.getStartTimeStr(), AFTConstants.YYYYMMDDHHMMSS));
            in.setReleaseEnd(DateUtils.StringToDate(in.getEndTimeStr(), AFTConstants.YYYYMMDDHHMMSS));
        }

        //计算总金额
        if (in.getTotalAmount()==null){
            in.setTotalAmount(expenseAccountDetailsMapper.selectAmountCountByEAid(in.getId()));
        }
        in.setProcessStatus(0);
        if (useEA.getStatus()==0){
            addExpenseAccountLogAndNoticEmail(in,0,"发起报销审核");
        }else if (useEA.getStatus()==3){
            addExpenseAccountLogAndNoticEmail(in,4,"修改并发起审核");
        }

        if (in.getOrderNo()==null){
            in.setTargetType(0);
        }else {
            in.setTargetType(1);
        }
        //计算本单已扣金额  如果有选择借支单，则需要修改借支状态
        if (in.getDebitId()!=null){
            //如果以前没有选择借支,修改报销和借支数据
            if (useEA.getDebitId()==null){
                pushExpenseAccountDebit(in);
            }else  if (useEA.getDebitId()!=in.getDebitId()) {
                //如果是修改编号
                pushExpenseAccountDebit(in);
                //并且要处理原编号的问题
                pushresettingDebit(in,useEA.getDebitId());
            }

        }
        return expenseAccountMapper.updateByPrimaryKeySelective(in);
    }

    private void pushresettingDebit(InputExpenseAccount in, Integer debitId) {
        ExpenseAccount debit = expenseAccountMapper.selectByPrimaryKey(debitId);
        List<ExpenseAccount> list = expenseAccountMapper.selectByDebitId(debitId);
        ExpenseAccount newdebit=new ExpenseAccount();
        newdebit.setId(debitId);
        //计算除开当前单，已选择抵扣金额
        BigDecimal count=new BigDecimal(0);
        for (ExpenseAccount e : list) {
            if (!in.getId().equals(e.getId())){
                count=count.add(e.getSettlementAmount());
            }
        }
        newdebit.setSettlementAmount(count);
        if (count.compareTo(new BigDecimal(0))==0){
            newdebit.setLiquidationStatus(0);
        }else if (count.compareTo(debit.getTotalAmount())<0){
            newdebit.setLiquidationStatus(1);
        }else if (count.compareTo(debit.getTotalAmount())==0){
            newdebit.setLiquidationStatus(2);
        }
        expenseAccountMapper.updateByPrimaryKeySelective(newdebit);
    }



    private void pushExpenseAccountDebit(InputExpenseAccount in) {
        ExpenseAccount debit = expenseAccountMapper.selectByPrimaryKey(in.getDebitId());
        ExpenseAccount newDebit=new ExpenseAccount();
        newDebit.setId(debit.getId());
        //计算剩余需要支付金额
        BigDecimal decbitAmount=debit.getTotalAmount().subtract(debit.getSettlementAmount());
        //本次金额大于等于需要抵扣金额，则变成完全抵扣，抵扣金额变成本次已付金额
        if (in.getTotalAmount().compareTo(decbitAmount)>=0){
            in.setSettlementAmount(decbitAmount);
            newDebit.setSettlementAmount(debit.getTotalAmount());
            newDebit.setLiquidationStatus(2);
        }else {
//           本次金额小于需要抵扣，则本次变更全抵扣，借支已付加上本次金额
            in.setSettlementAmount(in.getTotalAmount());
            BigDecimal setAmount=new BigDecimal(0).add(debit.getSettlementAmount()).add(in.getTotalAmount());
            newDebit.setSettlementAmount(setAmount);
            newDebit.setLiquidationStatus(1);
        }
        expenseAccountMapper.updateByPrimaryKeySelective(newDebit);
    }

    @Override
    public int addDetails(InputExpenseAccountDetails in) {
        if (in.getAgreeTimes()!=null){
            in.setAgreeTime(DateUtils.StringToDate(in.getAgreeTimes(),AFTConstants.YYYYMMDD));
        }
        return expenseAccountDetailsMapper.insertSelective(in);
    }

    @Override
    public int deleteDetails(Integer id) {
        return expenseAccountDetailsMapper.deleteByPrimaryKey(id);
    }

    @Override
    public List<OutExpenseAccountDetails> detailsList(Integer eaid) {

        return expenseAccountDetailsMapper.selectByEAid(eaid);
    }

    @Override
    public Object logList(Integer eaid) {
        List<OutExpenseAccountLog> list = expenseAccountLogMapper.selectByEaid(eaid);
        int maxProcessStatus=0;
        if (!list.isEmpty()){
        OutExpenseAccountLog lastout=list.get(list.size()-1);
        if (lastout.getStatus()!=3)maxProcessStatus=lastout.getProcessStatus();
        }
        List<OutExpenseAccountLog> eaelist = expenseAccountExamineMapper.selectNotExamineByEaidAndProcessStatus(eaid, maxProcessStatus);
        list.addAll(eaelist);
        return list;
    }




    @Override
    public int updateExamine(InputExpenseAccount in) {
        ExpenseAccount useEa = expenseAccountMapper.selectByPrimaryKey(in.getId());
        ExpenseAccount newEa=new ExpenseAccount();
        newEa.setId(useEa.getId());
        //审核通知 获取发送人
        addExamineExpenseAccountLog(in, useEa, newEa);
        //完成申请
        if (newEa.getStatus()==2){
            //如果是借支则订单新增
            if (useEa.getType()!=4){
                //不然就看是否挂载借支订单进行抵扣
                if (useEa.getDebitId()!=null){
                    ExpenseAccount useDebit=expenseAccountMapper.selectByPrimaryKey(useEa.getDebitId());
                    if (useDebit.getLiquidationStatus()==2){
                        List<ExpenseAccount> expenseAccounts = expenseAccountMapper.selectByDebitId(useEa.getDebitId());
                        boolean flag=true;
                        for (ExpenseAccount expenseAccount : expenseAccounts) {
                            if(!expenseAccount.getId().equals(in.getId())&&expenseAccount.getStatus()!=2){
                                flag=false;
                                break;
                            }
                        }
                        if (flag){
                            ExpenseAccount debit=new ExpenseAccount();
                            debit.setId(useEa.getDebitId());
                            debit.setLiquidationStatus(3);
                            expenseAccountMapper.updateByPrimaryKeySelective(debit);
                        }

                    }
                }
            }
        }
            //审核处理审核表
            pushExpenseAccountExamine(in);
        expenseAccountMapper.updateByPrimaryKeySelective(newEa);
        return 1;
    }

    private void pushExpenseAccountExamine(InputExpenseAccount in) {
        if (in.getStatus()==1){
            expenseAccountExamineMapper.updateStatusByEaidAndAid(in.getId(),TokenManager.getAdminId(),1);
        }else if (in.getStatus()==3){
            expenseAccountExamineMapper.updateStatusByEaidAndAid(in.getId(),null,0);
        }
    }

    private void addExamineExpenseAccountLog(InputExpenseAccount in, ExpenseAccount useEa, ExpenseAccount newEa) {
        List<Admin> aids=new ArrayList<>();
        StringBuffer str=new StringBuffer();
        Integer status=in.getStatus();
        AdminListBo admin = adminMapper.getDeptNameByAid(useEa.getAid());
        if (status==1){
            str=str.append("您有报销需要审核，").append("报销编号[").append(in.getId()).append("]").append("，请查看并审核。");
            //新的流程是当前流程+1
            newEa.setProcessStatus(useEa.getProcessStatus()+1);
            pushExamineProcess(newEa);
            if (newEa.getProcessStatus()== EAProcessStatus.CWSH.getCode()){
                //获取财务负责人
                Admin finaceAdmin = adminMapper.selectByPrimaryKey(admin.getDepFinance());
                aids.add(finaceAdmin);
                newEa.setExamineName(finaceAdmin.getName());
            }else if (newEa.getProcessStatus()== EAProcessStatus.ZJLSH.getCode()){
                //获取部门负责人
                List<Admin> list = adminMapper.listAdminBydepIdAndRoleType(admin.getDepartmentId(), AFTConstants.SALESMAN_ADMIN);
                if (!list.isEmpty())aids.addAll(list);
                newEa.setExamineName(getAdmins(list));
            }else if (newEa.getProcessStatus()== EAProcessStatus.DSZSH.getCode()){
                //获取总裁、董事长等审核
                List<Admin> list = adminMapper.selectAdminByRoleType(AFTConstants.All_CED_AND_CHAIRMAN);
                if (!list.isEmpty())aids.addAll(list);
                newEa.setExamineName(getAdmins(list));
            }else if (newEa.getProcessStatus()== EAProcessStatus.WCSH.getCode()){
                //获取报销申请人
                status =2;
                Admin finaceAdmin = adminMapper.selectByPrimaryKey(admin.getDepFinance());
                aids.add(finaceAdmin);
                str.setLength(0);
                str=str.append("您的报销审核已通过，报销编号[").append(in.getId()).append("]，请注意查看。");
                addNoticeAndEmail(in,  status,str.toString(),admin.getName(),aids);
                aids.clear();
                aids.add(adminMapper.selectByPrimaryKey(admin.getId()));
                newEa.setStatus(status);
                newEa.setExamineName("");

            }
        }else {
            aids.add(adminMapper.selectByPrimaryKey(admin.getId()));
            newEa.setStatus(3);
            newEa.setProcessStatus(0);
            str.setLength(0);
            str=str.append("您的报销审核已驳回，报销编号[").append(in.getId()).append("]，请注意查看。");
        }
        if (newEa.getStatus()==null)newEa.setStatus(1);
        addExpenseAccountLog(in.getId(),status,useEa.getProcessStatus(),TokenManager.getAdminId(),in.getReason());
        addNoticeAndEmail(in,  status,str.toString(),admin.getName(),aids);
    }

    private void pushExamineProcess( ExpenseAccount newEa) {
        //如果到了董事长审核，无需判断了
        if (newEa.getProcessStatus()<EAProcessStatus.WCSH.getCode()){
            //判断没一个流程是否可以跳过
             examineByprocess(newEa);
        }
    }

    /**
     * 审核流程推送，只要不是完成状态就继续判断是否跳过
     * @param newEa
     */
    private void examineByprocess( ExpenseAccount newEa) {
        //获取当前流程审核人，如果有已审核则跳过当前审核
        List<ExpenseAccountExamine> list = expenseAccountExamineMapper.selectByEaidAndProcessStatus(newEa.getId(), newEa.getProcessStatus());
        boolean flag=false;
        String aid="";
        for (ExpenseAccountExamine e : list) {
            if (e.getStatus()==1){
                flag=true;
                aid=e.getAuditor();
                break;
            }
        }
        if (flag){
            String str=String.format("重复审核人跳过[%s]。",EAProcessStatus.getDesc(newEa.getProcessStatus()));
            Date date=new Date();
            date.setTime(date.getTime()+1000l);
            addExpenseAccountLog(newEa.getId(),1,newEa.getProcessStatus(),aid,str,date);
            newEa.setProcessStatus(newEa.getProcessStatus()+1);
            if (newEa.getProcessStatus()<EAProcessStatus.WCSH.getCode())examineByprocess(newEa);
        }

    }

    private String getAdmins(List<Admin> list) {
        StringBuffer str =new StringBuffer();
        for (Admin admin : list) {
            str=str.append(admin.getName()).append(",");
        }
        return str.substring(0,str.length()-1);
    }

    private void addNoticeAndEmail(InputExpenseAccount in, Integer status, String str,String aname, List<Admin> aids) {
        Date date= new Date();

        Integer noticeStatus=NoticeStatus.EXPENSE_NOTICE.getCode();
        if (status==2){
            noticeStatus=NoticeStatus.EXPENSE_COMPLETE.getCode();
        }
        List<Notice> list=new ArrayList<>();
        if (aids!=null){
            for (Admin a : aids) {
                Notice notice=new Notice();
                notice.setId(UUID.randomUUID().toString());
                notice.setNoticeType(noticeStatus);
                notice.setType(NoticeTypes.getType(noticeStatus));
                notice.setAid(a.getId());
                notice.setCreateTime(date);
                notice.setContent(str);
                notice.setReaded(0);
                list.add(notice);
                EmailBo emailBo=new EmailBo(NoticeStatus.getValueByCode(noticeStatus),a.getEmail(),str);
                asyncUtils.send(emailBo);
                weChatUtils.addExpenseAccountWeChatNotice(a.getExpenseOpenId(),status,in.getId(),date,aname,str);
            }
        asyncUtils.addNoticeBatch(list);
        }
    }

    @Override
    public Object pageList(InputPageListBo in) {
        Map<String ,Object> param=new HashMap<>();
        addParam(in, param);
        Pagination<?> pagePlus = findPagePlus("selectExpenseAccountList",
                "selectExpenseAccountCount",
                "selectExpenseAccountTotalAmount", param, in.getPageNo(), in.getPageSize());
        List<OutExpenseAccountBo> list = (List<OutExpenseAccountBo>) pagePlus.getList();
        for (OutExpenseAccountBo e : list) {
            e.setExamine(pushExpenseAccountGetExamine(e.getId(), e.getProcessStatus()));
        }
        return pagePlus;
    }

    @Override
    public Object selectByPrid(InputExpenseAccount in) {
        Integer id=null;
        in.setAid(TokenManager.getAdminId());
        OutExpenseAccount useEa = expenseAccountMapper.selectByaidAndPrid(in);
        if (useEa!=null&&useEa.getId()!=null)id=useEa.getId();
        return id;
    }

    @Override
    public Object selectById(Integer id) {
        OutExpenseAccount useEa = expenseAccountMapper.selectByid(id);
        //判断当前角色是否审核
        pushExpenseAccountGetExamine(useEa);
        if (useEa.getDebitId()!=null){
            pushExpenseAccountGetDebitAmount(useEa);

        }
        return useEa;
    }

    /**
     * 计算当前报销显示抵扣金额
     * @param useEa
     */
    private void pushExpenseAccountGetDebitAmount(OutExpenseAccount useEa) {
        ExpenseAccount debit = expenseAccountMapper.selectByPrimaryKey(useEa.getDebitId());
        List<ExpenseAccount> list1 = expenseAccountMapper.selectByDebitId(useEa.getDebitId());
        BigDecimal count =debit.getTotalAmount();
        for (ExpenseAccount e : list1) {
            if (!e.getId().equals(useEa.getId())){
                count=count.subtract(e.getSettlementAmount());
            }
        }
        if (count.compareTo(new BigDecimal(0))<0)count=new BigDecimal(0);
        useEa.setDebitTotalAmount(count);
    }

    /**
     * 判断角色是否已经审核
     * @param useEa
     */
    private void pushExpenseAccountGetExamine(OutExpenseAccount useEa) {
        List<ExpenseAccountExamine> list = expenseAccountExamineMapper.selectByEaidAndProcessStatus(useEa.getId(), useEa.getProcessStatus());
        boolean flag=false;
        for (ExpenseAccountExamine e : list) {
            if (e.getAuditor().equals(TokenManager.getAdminId())){
                if (e.getStatus()==0){
                    flag=true;
                    break;
                }
            }
        }
        if (flag){
            useEa.setExamine(1);
        }else {
            useEa.setExamine(0);
        }
    }

    /**
     * 判断角色是否已经审核
     * @param
     */
    private Integer pushExpenseAccountGetExamine(Integer id,Integer processStatus) {
        List<ExpenseAccountExamine> list = expenseAccountExamineMapper.selectByEaidAndProcessStatus(id, processStatus);
        boolean flag=false;
        for (ExpenseAccountExamine e : list) {
            if (e.getAuditor().equals(TokenManager.getAdminId())){
                if (e.getStatus()==0){
                    flag=true;
                    break;
                }
            }
        }
        if (flag){
            return 1;
        }else {
            return 0;
        }
    }

    @Override
    public Object updateType(InputExpenseAccount in) {
        expenseAccountDetailsMapper.deleteByeaid(in.getId());
        return expenseAccountMapper.updateByPrimaryKeySelective(in);
    }

    @Override
    public List<OutExpenseAccount> selectDebitOrder(String depId,Integer id) {
        String aid= TokenManager.getAdminId();
        List<OutExpenseAccount> list = expenseAccountMapper.selectByaidAndType(aid, depId, 4,id);
        return list;
    }



    private void addParam(InputPageListBo in, Map<String, Object> param) {
        if (in.getStartTime()!=null&&in.getEndTime()!=null){
            param.put("startTime",in.getStartTime());
            param.put("endTime",in.getEndTime()+" 23:59:59");
        }
        if (in.getStatus()!=null)param.put("status",in.getStatus());
        //如果前端未传 0自己 1审核的参数，默认自己，在审核列表的时候判断Aid,在
        if (in.getProcessStatus()==null) in.setProcessStatus(0);
        param.put("processStatus",in.getProcessStatus());
         if(in.getProcessStatus()==2){
                if (in.getAid()!=null){
                    param.put("aid",in.getAid());
                }
        }else if(in.getProcessStatus()==1) {
             param.put("auditor",TokenManager.getAdminId());
             if (in.getAid()!=null){
                 param.put("aid",in.getAid());
             }
         }else {
            param.put("aid",TokenManager.getAdminId());
        }


        if (in.getExamineStatus()!=null){
            param.put("examineStatus",in.getExamineStatus());
        }else {
            param.put("examineStatus",0);
        }
        if (in.getContractNo()!=null)param.put("contractNo",in.getContractNo());
        if (in.getDepId()!=null)param.put("depId",in.getDepId());
        if (in.getUsername()!=null)param.put("username",in.getUsername());
        if (in.getApplyDep()!=null)param.put("applyDep",in.getApplyDep());
        if (in.getPayDep()!=null)param.put("payDep",in.getPayDep());
        if (in.getType()!=null)param.put("type",in.getType());
    }

    /**
     * 检查权限判断是否是总裁、董事长或超级管理员权限
     * @return
     */
    private boolean checkShiroCED() {
        if (TokenManager.hasRole(AFTConstants.CED)||TokenManager.hasRole(AFTConstants.CED_ASSISTANT)||
                TokenManager.hasRole(AFTConstants.SUPERADMIN)||TokenManager.hasRole(AFTConstants.APPROVAL_DECISION_ASSISTANT)
        ||TokenManager.hasRole(AFTConstants.APPROVAL_DECISION)){
            return true;
        }
        return false;
    }


    @Override
    @Cacheable(value = "expenseAccountStatistics#300", key = "'page:'+#name+',depId'+#depId+',startTime'+#startTime+',endTime'+#endTime")
    public List<OutExpenseAccountStatistics> statistics(String name,String depId,String startTime,String endTime) {
        if (endTime!=null)endTime=endTime+" 23:59:59";
        List<OutMyEAStatistics> list = expenseAccountMapper.selectStatistics(name, depId, startTime, endTime);
        List<OutExpenseAccountStatistics> results=new ArrayList<>();
        Map<String ,Object> map=new HashMap<>();
        for (OutMyEAStatistics e : list) {
            OutExpenseAccountStatistics out = new OutExpenseAccountStatistics(e.getAid());
            out.setAname(e.getAname());
            if (e.getStatus() == 2) {
                if (e.getType() < 4) {
                    out.setBx(1);
                    out.setBxAmount(e.getTotalAmount());
                    if (!e.getDebitId().equals(0)) {
                        out.setDk(1);
                        out.setDkAmount(e.getBxdkAmount());
                    }
                } else if (e.getType() == 4) {
                    out.setJz(1);
                    out.setJzAmount(e.getTotalAmount());
                } else if (e.getType() == 5) {
                    out.setDk(1);
                    out.setDkAmount(e.getTotalAmount());
                }

                if (e.getTargetType() == 0) {
                    out.setGdfyAmount(e.getTotalAmount());
                } else if (e.getTargetType() == 1) {
                    out.setBxddAmount(e.getTotalAmount());
                }

            } else if (e.getStatus() < 2) {
                out.setWshs(1);
            } else if (e.getStatus() == 3) {
                out.setBhs(1);
            }
            //如果不存在就新增
            if (!map.keySet().contains(out.getAid())){
                List<OutExpenseAccountStatistics> list2=new ArrayList<>();
                list2.add(out);
                map.put(out.getAid(),list2);
            }else {
                List<OutExpenseAccountStatistics> list2 = (List<OutExpenseAccountStatistics>) map.get(e.getAid());
                list2.add(out);
            }
        }
        for (String s : map.keySet()) {
            List<OutExpenseAccountStatistics> list3 = (List<OutExpenseAccountStatistics>) map.get(s);
            if (!list3.isEmpty()){
                OutExpenseAccountStatistics out =new OutExpenseAccountStatistics(s);

                for (OutExpenseAccountStatistics e : list3) {
                    if (out.getAname()==null)out.setAname(e.getAname());
                    if (e.getBx()!=null)out.setBx(out.getBx()+e.getBx());
                    if (e.getJz()!=null)out.setJz(out.getJz()+e.getJz());
                    if (e.getDk()!=null)out.setDk(out.getDk()+e.getDk());
                    if (e.getBxAmount()!=null)out.setBxAmount(out.getBxAmount().add(e.getBxAmount()));
                    if (e.getJzAmount()!=null)out.setJzAmount(out.getJzAmount().add(e.getJzAmount()));
                    if (e.getDkAmount()!=null)out.setDkAmount(out.getDkAmount().add(e.getDkAmount()));
                    if (e.getGdfyAmount()!=null)out.setGdfyAmount(out.getGdfyAmount().add(e.getGdfyAmount()));
                    if (e.getBxddAmount()!=null)out.setBxddAmount(out.getBxddAmount().add(e.getBxddAmount()));
                    if (e.getWshs()!=null)out.setWshs(out.getWshs()+e.getWshs());
                    if (e.getBhs()!=null)out.setBhs(out.getBhs()+e.getBhs());
                }
                BigDecimal totalAmount=new BigDecimal(0);
                totalAmount=totalAmount.add(out.getBxAmount()).add(out.getJzAmount()).subtract(out.getDkAmount());
                out.setTotalAmount(totalAmount);
                results.add(out);
            }

        }
        return results;
    }

    @Override
    @CacheEvict(value = "expenseAccountStatistics#300", allEntries = true)
    public void statisticsEvict(String name, String depId, String startTime, String endTime) {
        LoggerUtils.debug(getClass(), "报销统计清楚缓存。");
    }




}
